#INCLUDE Functions.H
LOCAL oApp
LOCAL oBDE
LOCAL cDirectory

SET DIRECTORY TO (DirectoryOnly(PROGRAM(0))) //Steht in Include-Datei Functions.H
SET PROCEDURE TO PROGRAM(0) //Hauptprogramm
//Standardumgebung ausblenden
SET PROCEDURE TO BDE_Min.CC ADDITIVE //Minimalfunktionen fr BDE laden
oBDE=new BDE_Min()
oBDE.Init()
IF .NOT. oBDE.DatabaseFound("DBKON04LC")
   cDirectory=SET("DIRECTORY")
   cDirectory=SetSlash(cDirectory)  //Steht in Include-Datei Functions.H
   oBDE.CreateAlias("DBKON04LC",cDirectory+"Data")
ENDIF
_app.DatabasePath=oBDE.DatabaseDir("DBKON04LC")
SHELL(false)
//Andere Module anmelden
_app.ShutDown=false         //Flag fr Schlieen 
oApp=new dBKON04App()       //Anwendungsobjekt anlegen
_app.speedbar=false
_app.statusbar=true
RETURN oApp.open()

CLASS dBKON04App
   SET PROCEDURE TO dBKon04.MNU ADDITIVE  //Hauptmen
   _app.frameWin.app=this
   this.rootMenu  =new dBKON04Menu(_app.framewin,"Root")

   FUNCTION Open
   LOCAL f
   f=new DummyForm()
   f.open()
   RETURN true

   FUNCTION Beenden
   _app.ShutDown=true
   CLOSE FORMS
   this.close()
   RETURN

   FUNCTION OpenEinsatz1
   LOCAL f
   f=FINDINSTANCE("Einsatz1Form")
   IF f=NULL
      SET PROCEDURE TO Einsatz1.WFM ADDITIVE
      f=new Einsatz1Form()
      f.app=this
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenEinsatz2
   LOCAL f
   f=FINDINSTANCE("Einsatz2Form")
   IF f=NULL
      SET PROCEDURE TO Einsatz2.WFM ADDITIVE
      f=new Einsatz2Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenEinsatz3
   LOCAL f
   f=FINDINSTANCE("Einsatz3Form")
   IF f=NULL
      SET PROCEDURE TO Einsatz3.WFM ADDITIVE
      f=new Einsatz3Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenEinsatz4
   LOCAL f
   f=FINDINSTANCE("Einsatz4Form")
   IF f=NULL
      SET PROCEDURE TO Einsatz4.WFM ADDITIVE
      f=new Einsatz4Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenEinsatz5
   LOCAL f
   f=FINDINSTANCE("Einsatz5Form")
   IF f=NULL
      SET PROCEDURE TO Einsatz5.WFM ADDITIVE
      f=new Einsatz5Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenEinsatz6
   LOCAL f
   f=FINDINSTANCE("Einsatz6Form")
   IF f=NULL
      SET PROCEDURE TO Einsatz6.WFM ADDITIVE
      f=new Einsatz6Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenEinsatz7
   LOCAL f
   f=FINDINSTANCE("Einsatz7Form")
   IF f=NULL
      SET PROCEDURE TO Einsatz7.WFM ADDITIVE
      f=new Einsatz7Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenEinsatz8
   LOCAL f
   f=FINDINSTANCE("Einsatz8Form")
   IF f=NULL
      SET PROCEDURE TO Einsatz8.WFM ADDITIVE
      f=new Einsatz8Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenTree1
   LOCAL f
   f=FINDINSTANCE("Tree1Form")
   IF f=NULL
      SET PROCEDURE TO Tree1.WFM ADDITIVE
      f=new Tree1Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenTree2
   LOCAL f
   f=FINDINSTANCE("Tree2Form")
   IF f=NULL
      SET PROCEDURE TO Tree2.WFM ADDITIVE
      f=new Tree2Form()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenTree2a
   LOCAL f
   f=FINDINSTANCE("Tree2aForm")
   IF f=NULL
      SET PROCEDURE TO Tree2a.WFM ADDITIVE
      f=new Tree2aForm()
      f.app=this
      f.Init()
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenTree3
   LOCAL f
   f=FINDINSTANCE("Tree3Form")
   IF f=NULL
      SET PROCEDURE TO Tree3.WFM ADDITIVE
      f=new Tree3Form()
      f.app=this
      f.Init()
      CLASS::SetMenuAndBars(f,false)   //Workaround fr Popup
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenTree4
   LOCAL f
   f=FINDINSTANCE("Tree4Form")
   IF f=NULL
      SET PROCEDURE TO Tree4.WFM ADDITIVE
      f=new Tree4Form()
      f.app=this
      f.Init()
      CLASS::SetMenuAndBars(f,false)   //Workaround fr Popup
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION OpenTree5
   LOCAL f
   f=FINDINSTANCE("Tree5Form")
   IF f=NULL
      SET PROCEDURE TO Tree5.WFM ADDITIVE
      f=new Tree5Form()
      f.app=this
      f.Init()
      CLASS::SetMenuAndBars(f,false)   //Workaround fr Popup
      f.open()
   ELSE
      f.windowstate=0
      f.setFocus()
   ENDIF
   RETURN

   FUNCTION Close
   LOCAL f
   CLOSE FORMS
   IF "runtime"$LOWER(VERSION(1))
      QUIT
      RETURN
   ELSE
      _app.speedbar=true
      this.rootMenu  =null
      SET PROCEDURE TO
      f=new FORM()
      f.visible=false
      f.open()
      SLEEP 1 
      f.close()
      f.release()
      SHELL(true,true)
   ENDIF
   RETURN

   FUNCTION SetMenuAndBars
   PARAMETERS oForm,lShow
   LOCAL m
            
   m=new dBKON04Menu(oForm,"Root")
   IF ARGCOUNT()<2
      lShow=false
   ENDIF
   IF TYPE("oForm.app.toolbars.databar")=="O" .AND. lShow
      this.toolbars.databar.attach(oForm)
   ENDIF
   RETURN
ENDCLASS


CLASS DummyForm OF FORM
   with(this)
      visible=false
      canClose = CLASS::CANCLOSE
   endwith

   FUNCTION canClose
   LOCAL lClose
   lClose=_app.ShutDown
   RETURN lClose
ENDCLASS