#DEFINE ALLTRIM(cString)               IIF(EMPTY(cString),"",TRIM(LTRIM(cString)))
#DEFINE DM2EURO(nNumeric)              nNumeric/1.95583
#DEFINE EURO2DM(nNumeric)              nNumeric*1.95583
#DEFINE NAMEANDPATH(cFile,cPath)       IIF(EMPTY(cPath),TRIM(cFile),TRIM(cPath)+IIF(RIGHT(TRIM(cPath),1)="\","","\")+TRIM(cFile))
#DEFINE MONATSBEGINN(dDatum)           dDatum-DAY(dDatum)+1
#DEFINE MONATPOS(cMonat)               STR((AT(UPPER(LEFT(cMonat,3)),"JAN FEB MR APR MAI JUN JUL AUG SEP OKT NOV DEZ")-1)/4+1,2,0,"0")
#DEFINE DaysOfMonth(dDatum)            DAY(CTOD("01."+LTRIM(STR(MONTH(dDatum+32-DAY(dDatum))))+"."+LTRIM(STR(YEAR(dDatum+32-DAY(dDatum)))))-1)
#DEFINE FDateTime(cFile)               CTODT(FDATE(cFile)+" "+FTIME(cFile))
#DEFINE Monatsende(dDatum)             CTOD("01."+STR(MONTH(CTOD("01."+STR(MONTH(dDatum))+"."+STR(YEAR(dDatum)))+40))+"."+STR(YEAR(CTOD("01."+STR(MONTH(dDatum))+"."+STR(YEAR(dDatum)))+40)))-1
#DEFINE Zeitraum(dDatum)               IIF(RIGHT(DTOS(dDatum),4)>"1220",STR(YEAR(dDatum)+1,4,0)+"01",STR(YEAR(dDatum),4,0)+STR(MONTH(dDatum),2,0,"0"))
#DEFINE CutKommentar(cText)            IIF(LEN(TRIM(LTRIM(cText)))>5,cText,"")
#DEFINE DiskspaceAlpha(cPath)          IIF(EMPTY(cPath),DISKSPACE(ASC(UPPER(LEFT(SET("DIRECTORY"),1)))-64),DISKSPACE(ASC(UPPER(LEFT(cPath,1)))-64))
#DEFINE LSTR(nValue)                   LTRIM(STR(nValue))
#DEFINE FilenameOnly(cFilename)        RIGHT(cFilename,LEN(cFilename)-RAT("\",cFilename))
#DEFINE DirectoryOnly(cFilename)       IIF(LEN(cFilename)>3,LEFT(cFilename,RAT("\",cFilename)),cFilename)
#DEFINE AddSymbol(cText,nSpace)        cText+SPACE(nSpace)+"<font face='Symbol' size=3></font>"+SPACE(nSpace)
#DEFINE LowByte(nValue)                MOD(nValue,256)
#DEFINE HighByte(nValue)               INT(nValue/256)
#DEFINE Lebensalter(dBeginn,dEnde)     YEAR(dEnde)-YEAR(dBeginn)-IIF(RIGHT(DTOS(dBeginn),4)>RIGHT(DTOS(dEnde),4),1,0)
#DEFINE DTTOS(dtDatetime)              STR(YEAR(dtDateTime),4,0,"0")+STR(MONTH(dtDateTime),2,0,"0")+STR(DAY(dtDateTime),2,0,"0")+SUBSTR(DTTOC(dtDatetime),12,2)+SUBSTR(DTTOC(dtDatetime),15,2)+SUBSTR(DTTOC(dtDatetime),18,2)
#DEFINE DateAndTime2DT(dDatum,cZeit)   CTODT(DTOC(dDatum)+" "+LEFT(cZeit,2)+":"+SUBSTR(cZeit,3,2)+":"+RIGHT(cZeit,2))
#DEFINE Jahresanfang(dDatum)           CTOD("01.01."+STR(YEAR(dDatum),4,0,"0"))
#DEFINE Jahresende(dDatum)             CTOD("31.12."+STR(YEAR(dDatum),4,0,"0"))
#DEFINE Stunden(cBeginn,cEnde)         (VAL(LEFT(cEnde,2))*60+VAL(RIGHT(cEnde,2))-VAL(LEFT(cBeginn,2))*60-VAL(RIGHT(cBeginn,2)))/60
#DEFINE PrinterError()                 MSGBOX("Fehler beim Laden des Druckertreibers."+CHR(10)+"Es werden Standardeinstellungen verwendet.","Hinweis",48)
#DEFINE VollesDatum(dDatum)            STR(DAY(dDatum),2,0,"0")+". "+CMONTH(dDatum)+" "+STR(YEAR(dDatum),4,0,"0")
#DEFINE YearAndMonth(nJahr,nMonat)     STR(nJahr,4,0,"0")+STR(nMonat,2,0,"0") 
#DEFINE Monatsname(nMonat)             CMONTH(CTOD("01."+STR(nMonat,2,0,"0")+".2001"))
#DEFINE STOD(cString)                  CTOD(IIF(LEN(cString)=8,RIGHT(cString,2)+"."+SUBSTR(cString,5,2)+"."+LEFT(cString,4),RIGHT(cString,2)+"."+SUBSTR(cString,3,2)+"."+LEFT(cString,2)))
#DEFINE DT2Time(dtDatetime,nRet)       RIGHT(DTTOC(dtDatetime),8)
#DEFINE Min2Hours(nMinutes)            IIF(nMinutes>1439,"**:**",STR(INT(nMinutes/60),2,0,"0")+":"+STR(MOD(nMinutes,60),2,0,"0"))
#DEFINE Min2Hours2(nMinutes)           STR(INT(nMinutes/60),4,0,"0")+STR(MOD(nMinutes,60),2,0,"0")   //Achtung! Nur positive Werte zulssig
#DEFINE Min2Hours3(nMinutes)           IIF(nMinutes<0,"-","+")+STR(INT(ABS(nMinutes)/60),3,0,"0")+STR(MOD(ABS(nMinutes),60),2,0,"0")
#DEFINE Time2Minutes(cTime)            VAL(LEFT(cTime,2))*60+VAL(RIGHT(cTime,2))    
#DEFINE Time2MinutesLong(cTime)        VAL(LEFT(cTime,LEN(cTime)-IIF(":"$cTime,3,2)))*60+VAL(RIGHT(cTime,2))    
#DEFINE Wochenbeginn(dDatum)           IIF(DOW(dDatum)=1,dDatum-6,dDatum-DOW(dDatum)+2)
#DEFINE Fehler(cError)                 MSGBOX(cError,"Achtung",16)
#DEFINE PersFilename()                 DTOS(DATE())+"_"+SUBSTR(TIME(),1,2)+SUBSTR(TIME(),4,2)+SUBSTR(TIME(),7,2)
#DEFINE SetSlash(cDirectory)           cDirectory+IIF(RIGHT(cDirectory,1)=="\","","\")
#DEFINE DatetimeCreated(dDatum,cZeit)  CTODT(DTOC(dDatum)+" "+cZeit)
#DEFINE PrinterError2(cPrinter)        MSGBOX("Beim Drucken "+IIF(EMPTY(cPrinter),"","auf "+TRIM(cPrinter)+CHR(10))+"ist ein Fehler aufgetreten.","Achtung",16)
#DEFINE ErrorMsg(oError)               MSGBOX("Ein unerwarteter Fehler ist aufgetreten"+CHR(10)+"Routine: "+oError.Filename+CHR(10)+"Zeile: "+LTRIM(STR(oError.lineNo))+CHR(10)+"Code: "+LTRIM(STR(oError.code))+CHR(10)+oError.message,"Achtung",16)
#DEFINE GetDateLength()                LEN(DTOC(DATE()))
#DEFINE MSGBOXSave()                   MSGBOX("Der aktuelle Datensatz wurde gendert."+CHR(10)+"Mchten Sie die nderungen speichern?","Besttigung",4+32)
#DEFINE BeginnZeitraum(cZeitraum)      CTOD("01."+RIGHT(cZeitraum,2)+"."+LEFT(cZeitraum,4))
#DEFINE SekundenDauer(dtEnde,dtBeginn) (DTTOD(dtEnde)-DTTOD(dtBeginn))*86400+ELAPSED(dtEnde,dtBeginn)
#DEFINE NetError()                     MSGBOX("Datensatz konnte nicht gesperrt werden.","Netzwerkzugriff",16)
#DEFINE ErrBaustelle()                 MSGBOX("B a u s t e l l e"+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+CHR(10)+"                 Hier            geht                noch           gar         nix      !!!                ","",16)
#DEFINE MwStBasis(nEnthalten,nSatz)    nEnthalten/(1-1/(1+nSatz/IIF(nSatz>1,100,1)))
#DEFINE XML2String(cString,nLenXML)    SUBSTR(cString,nLenXML+1,LEN(cString)-2*nLenXML-1)
#DEFINE Zeitraum2Text(cZeitraum)       CMONTH(CTOD("01."+RIGHT(cZeitraum,2)+".1956"))+" "+LEFT(cZeitraum,4)
#DEFINE SteuerBrutto(nNetto,nSatz)     nNetto*(1+nSatz/IIF(nSatz>1,100,1))
#DEFINE SteuerNetto(nBrutto,nSatz)     nBrutto/(1+nSatz/IIF(nSatz>1,100,1))
#DEFINE IsRuntime()                    "runtime"$LOWER(VERSION(1))
#DEFINE GetExtension(cFilename)        RIGHT(cFilename,LEN(cFilename)-RAT(".",cFilename))
